<?php
/*
 ***********************************************************************************************
 * Purge Admidio Weblink Images Script
 *
 * @copyright 2017 John Schwartz Free Internet Pioneers
 *
 * @license https://www.gnu.org/licenses/gpl-2.0.html GNU General Public License v2.0 only
 *
 * Version: 1.0
 *
 ***********************************************************************************************
*/
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<title>Purge Admidio Weblink Images</title>
<meta name="description" content="Remove all unused files from admidio's weblinks/images folder">
<meta name="author" content="John Schwartz Free Internet Pioneers">
<style type="text/css">
body {margin-left:100px; font:14px arial, sans-serif; color:#203030; background:#DDECEE;}
div span {display:block; float:left; width:130px;}
.error {color:#DD0000; font-weight: bold;}
</style>
</head>

<body>
<h4>Purge Admidio Weblink Images</h4>
<?php
if (isset($_POST['exit'])) { echo "<p>Good bye!</p>\n"; goto end; } //exit button selected

error_reporting(E_ALL); //errors, warnings and notices - test
ini_set('display_errors',1); ini_set('log_errors',1); //test
 
require('./adm_program/system/common.php'); //get db credentials

$pin = '1234'; //pin code
$imgPath = "./adm_my_files/weblinks/images"; //image files path
$allNames = scandir("{$imgPath}"); //get image file names
$fileNames = array_filter($allNames,function($fName){return preg_match("%\.[a-z]{3,4}$%i",$fName);}); //flush non-file entries

$nrFilesBefore = count($fileNames); //number of images before purging

echo "<p>Initial number of files in the weblinks/images directory: {$nrFilesBefore}.<p>\n";

$dbH = new mysqli("localhost", $g_adm_usr, $g_adm_pw, $g_adm_db); //establish database connection

if (mysqli_connect_errno()) { //check connection
	printf("Connect failed: %s\n", mysqli_connect_error());	goto end;
}

if ($result = $dbH->query("SELECT `lnk_description` FROM `admidio_links`")) { //select all link decriptions
	while ($row = $result->fetch_row()) { //fetch a link description
		if (preg_match("%file=([^.]{2,15}\.(?:jpe?g|png|gif))%i",$row[0],$matches)) { //extract image file name ($matches[1])
			$key = array_search($matches[1],$fileNames); //check if image exists in array with file names
			if ($key !== false) { //found
				unset($fileNames[$key]); //remove name from array
			}
		}
	}
	$result->close(); //free result set
} else {
	echo("SQL error description: ".mysqli_error($dbH));
}
$dbH->close(); //close db connection

//Now array $fileNames only contains names of orphan files, if any
$nrFilesAfter = count($fileNames); //number of files to be deleted
echo "<p>Number of orphan files: {$nrFilesAfter}.</p>\n";
if ($nrFilesAfter == $nrFilesBefore) { //all files are orphans! Something went wrong
	echo "<p>No image from the links directory found in the database links!<br>Something must have gone wrong.<br>No images removed!</p>\n"; goto end;
}

if (!$nrFilesAfter) { echo "<p>Good bye!</p>\n"; goto end; } //no orphan files

$delete = (!empty($_POST['pin']) and $_POST['pin'] == $pin);

if (!$delete) {
	echo "<p>If you want to delete all orphan files listed below, enter the PIN and press Delete.</p>\n";
	echo "<form action='".htmlspecialchars($_SERVER["PHP_SELF"])."' method='post'>
<p>PIN: <input type='password' name='pin' size='4' maxlength='4'>".
(isset($_POST['pin']) ? " <span class='error'>no or incorrect PIN</span>" : '').
"</p>
<p><input type='submit' name='del' value='Delete'>&nbsp;&nbsp;<input type='submit' name='exit' value='Exit'></p>
</form>\n";
	echo "<p>The following files are orphans:</p>\n";
} else {
	echo "<p>The following files have been deleted:</p>\n";
}
$nr = 1;//init
echo "<div>\n";
foreach($fileNames as $imgName) { //file name to be deleted
	if ($delete) {
		unlink($imgPath.'/'.$imgName); //delete file
	}
	echo "<span>{$imgName}</span>".($nr % 8 ? '': "<br>\n"); //display file name
	$nr++;
}
echo "\n</div>\n";
end:
?>
</body>
</html>